
// ChangerDlg.cpp : implementation file
//-------------------------------------
#include "stdafx.h"
#include "Changer.h"
#include "ChangerDlg.h"
#include "MDBEngine.h"
#include "EXEDefines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CChangerDlg dialog
//-------------------

CChangerDlg::CChangerDlg(CWnd* pParent)	: CDialog(CChangerDlg::IDD, pParent)
//==========================================================================
{
	//{{AFX_DATA_INIT(CChangerDlg)
	m_dwCredit = 0;
	m_dwPrice = 0;
	m_VendFailure = FALSE;
	m_VendSuccess = FALSE;
	m_bExactChange = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChangerDlg::DoDataExchange(CDataExchange* pDX)
//==================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangerDlg)
	DDX_Text(pDX, IDC_CREDIT, m_dwCredit);
	DDX_Text(pDX, IDC_PRICE, m_dwPrice);
	DDX_Check(pDX, IDC_VEND_FAILURE, m_VendFailure);
	DDX_Check(pDX, IDC_VEND_SUCCESS, m_VendSuccess);
	DDX_Check(pDX, IDC_EXACTCHANGE, m_bExactChange);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChangerDlg, CDialog)
	//{{AFX_MSG_MAP(CChangerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_EXACTCHANGE, OnExactchange)
	ON_BN_CLICKED(IDC_REJECT, OnReject)
	ON_BN_CLICKED(IDC_COIN_10, OnCoin10)
	ON_BN_CLICKED(IDC_COIN_20, OnCoin20)
	ON_BN_CLICKED(IDC_COIN_50, OnCoin50)
	ON_BN_CLICKED(IDC_COIN_100, OnCoin100)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_EXE_STATUS,CChangerDlg::OnEXEStatus)
END_MESSAGE_MAP()

// CChangerDlg message handlers
//-----------------------------

BOOL CChangerDlg::OnInitDialog()
//==============================
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog
	//--------------------------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE); // Set small icon
	
	// Initialize MDB engine
	//----------------------
	EXECUTIVE_SETUP Setup; // I am executive master
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwDevice=0;
	Setup.dwTimeout=20;
	Setup.dwDecimals=2;
	Setup.dwFactor=1;
	Setup.dwVendTimeout=30;
	if (!VMCCreate(&Setup))
	{
		TRACE(_T("Failed to create VMC\r\n"));
	}
	return true;
}

void CChangerDlg::OnAboutbox()
//============================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CChangerDlg::OnPaint() 
//=========================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display 
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CChangerDlg::OnQueryDragIcon()
//====================================
{
	return (HCURSOR)m_hIcon;
}

void CChangerDlg::OnDestroy() 
//===========================
{
	CDialog::OnDestroy();
	if (!VMCDestroy())
	{
		TRACE(_T("Failed to destroy VMC\r\n"));
	}
}

void CChangerDlg::OnExactchange() 
//===============================
{
	UpdateData(true);
	VMCExactChange(m_bExactChange);
}

void CChangerDlg::OnEXEStatus(WPARAM wParam, LPARAM lParam)
//=========================================================
{
	switch (wParam)
	{
		case MS_EXE_READY:
		{
			break;
		}
		case MS_EXE_DISPLAY:
		{
			m_dwCredit=lParam;
			UpdateData(false);
			break;
		}
		case MS_EXE_SELECTION:
		{
			m_dwPrice=lParam;
			UpdateData(false);
			if (m_dwPrice<=m_dwCredit)
			{
				VMCVend();
			}
			break;
		}
		case MS_EXE_SUCCESS:
		{
			m_dwPrice=0;
			m_VendSuccess=true;
			m_VendFailure=false;
			UpdateData(false);
			break;
		}
		case MS_EXE_FAILURE:
		{
			m_dwPrice=0;
			m_VendSuccess=false;
			m_VendFailure=true;
			UpdateData(false);
			break;
		}
	}
}

void CChangerDlg::OnReject() 
//==========================
{
	m_dwCredit=0;
	UpdateData(false);
	VMCCredit(m_dwCredit);
}

void CChangerDlg::OnCoin10() 
//==========================
{
	m_dwCredit+=10;
	UpdateData(false);
	VMCCredit(m_dwCredit);
}

void CChangerDlg::OnCoin20() 
//==========================
{
	m_dwCredit+=20;
	UpdateData(false);
	VMCCredit(m_dwCredit);
}

void CChangerDlg::OnCoin50() 
//==========================
{
	m_dwCredit+=50;
	UpdateData(false);
	VMCCredit(m_dwCredit);
}

void CChangerDlg::OnCoin100() 
//===========================
{
	m_dwCredit+=100;
	UpdateData(false);
	VMCCredit(m_dwCredit);
}
